from dataclasses import dataclass, field
from typing import Any, Callable, Dict, Tuple, Union, List
from mqer.utils import import_obj_string


@dataclass(frozen=True)
class CallbackFunc:
    func: Callable[..., Any]
    args: Tuple[Any, ...] = field(default_factory=tuple)
    kwargs: Dict[Any, Any] = field(default_factory=dict)

    @classmethod
    def from_dict(cls, dict_values: Dict[str, Any]) -> 'CallbackFunc':
        func = dict_values["func"]
        return cls(
            func=import_obj_string(func) if isinstance(func, str) else func,
            args=dict_values.get("args", ()),
            kwargs=dict_values.get("kwargs", {})
        )


class EmptyObj:
    pass


emptyobj = EmptyObj()

JsonMsgBody = Union[Dict[str, Any], List]
